##################################################################################################
######## kol 2.4 - een ##############

# Skript provede zvyseni kontrastu obrazku pomoci vyrovnani 
# histogramu

#nacteni knihovny pro praci s obrazky
library(imager)
library(pracma)

#vycistime prostredi
remove(list = ls())
dev.off()

#nastavime cestu k adresari
setwd("/home/coosa/Documents/SKOMAM/2019/")

#nacteme obrazek se spatnym histogramem
uneq<-load.image("uneq.jpg")
uneq<-floor(uneq*255)
uneq_gray<-grayscale(uneq)
uneq_mat<-as.matrix(uneq_gray)

plot(as.cimg(uneq_gray/255),rescale=FALSE)

#nejprve si nastavime parametry
n_bins<-100
histogram<-zeros(1,n_bins)
minval<-0.0
maxval<-255

#vytvorime histogram
for (i in 1:n_bins) {
    upper<-minval + (maxval-minval)/n_bins *(i)
    lower<-minval + (maxval-minval)/n_bins *(i-1)
    if(i==n_bins){
        histogram[i]<-sum(uneq_mat>=lower & uneq_mat<=upper)
    } else {
        histogram[i]<-sum(uneq_mat>=lower & uneq_mat<upper)
    }
}

#vykreslime histogram
barplot(histogram,width = 1)

#narovname histogram
eq<-uneq_mat
minval<-min(uneq_mat)
maxval<-max(uneq_mat)
min(eq)
max(eq)
eq<-255*(eq - minval)/(maxval-minval)
plot(as.cimg(eq/255),rescale=FALSE)

hist(uneq,xlim = range(0,256))
hist(eq,xlim = range(0,256))
