##################################################################################################
######## kol 2.2 - een ##############

# Skript nacte obrazek do R pomoci prikazu imread, zobrazi
# tento obrazek pomoci funkce imshow a zobrazi jeho jednotlive slozky R,
# G a B. Dale prevede tento obrazek do stupnu sede pomoci funkce rgb2gray a
# ulozi jej pomoci funkce imwrite.

#nacteni knihovny pro praci s obrazky
library(imager)
library(pracma)

#vycistime prostredi
remove(list = ls())
dev.off()

#nastavime cestu k adresari
setwd("/home/coosa/Documents/SKOMAM/2019/")

#nacteme obrazek
lena<-load.image("seda_lena.png")
lena = floor(lena*255)
lena_mat<-as.matrix(lena)
rozmery=size(lena_mat)

vyska=rozmery[1]
sirka=rozmery[2]

x1<-floor(vyska/2.0) - 128
x2<-x1+256
y1<-floor(sirka/2.0) - 128
y2<-y1+256

vyrez<- lena_mat[x1:x2,y1:y2]

save.image(as.cimg(vyrez),'vyrez.png')
plot(as.cimg(vyrez))
