##################################################################################################
######## kol 2.3 - een ##############

# Skript provede zesvetleni a ztmaveni obrazku a vytvori jeho
# negativ. Dale provede prahovani s prahem 10, 100, 150, 200.

#nacteni knihovny pro praci s obrazky
library(imager)
library(pracma)

#vycistime prostredi
remove(list = ls())
dev.off()

#nastavime cestu k adresari
setwd("/home/coosa/Documents/SKOMAM/2019/")

#nacteme obrazek
obrazek<-load.image("vyrez.png")
obrazek = floor(obrazek*255)
obrazek_mat<-as.matrix(obrazek)
rozmery=size(obrazek_mat)

gray_crop = obrazek_mat
gray_mat = obrazek_mat

#zvyseni jasu
gray_bright<-gray_crop + 128
gray_bright[gray_bright>255]<-255
plot(as.cimg(gray_bright))
#snizeni jasu
gray_dark<-gray_crop - 128
gray_dark[gray_dark<0.0]<-0.0
plot(as.cimg(gray_dark))
#negativ
gray_negative<-255 - gray_crop
plot(as.cimg(gray_negative))

#prahovani -- vyzkousime na grayscale matici
#
#nastavime threshold
T<-10
gray_black_white<-gray_mat
gray_black_white[gray_black_white<T]<-0.0
gray_black_white[gray_black_white>=T]<-255
plot(as.cimg(gray_black_white))

T<-100
gray_black_white<-gray_mat
gray_black_white[gray_black_white<T]<-0.0
gray_black_white[gray_black_white>=T]<-255
plot(as.cimg(gray_black_white))

T<-150
gray_black_white<-gray_mat
gray_black_white[gray_black_white<T]<-0.0
gray_black_white[gray_black_white>=T]<-255
plot(as.cimg(gray_black_white))

T<-200
gray_black_white<-gray_mat
gray_black_white[gray_black_white<T]<-0.0
gray_black_white[gray_black_white>=T]<-255
plot(as.cimg(gray_black_white))

